import { Generator } from '@nx/devkit';
export declare const WEB_DEV_SERVER_PLUGIN_NAME = "@robby-rabbitman/nx-plus-web-dev-server/plugin";
export interface WebDevServerInitGeneratorSchema {
    /**
     * The name of the `web-dev-server` serve target e.g. 'serve' or
     * 'web-dev-server'.
     */
    serveTargetName?: string;
    /** Whether to skip adding the plugin. */
    skipAddPlugin?: boolean;
    /** Whether to skip formatting the updated files. */
    skipFormat?: boolean;
}
export type WebDevServerInitGeneratorOptions = Required<WebDevServerInitGeneratorSchema>;
/**
 * 1. Adds `@robby-rabbitman/nx-plus-web-dev-server/plugin` to the `plugins` of the
 *    `nx.json` when not already included. Can be skipped with `skipAddPlugin`.
 * 2. Formats the updated files. Can be skipped with `skipFormat`.
 *
 * @param {WebDevServerInitGeneratorSchema} [schema.serveTargetName="serve"]
 *   Default is `"serve"`
 * @param {WebDevServerInitGeneratorSchema} [schema.skipAddPlugin=true] Default
 *   is `true`
 * @param {WebDevServerInitGeneratorSchema} [schema.skipFormat=true] Default is
 *   `true`
 */
export declare const initGenerator: Generator<WebDevServerInitGeneratorSchema>;
export default initGenerator;
export declare const createWebDevServerPluginConfiguration: ({ options, webDevServerPluginName, }: {
    options: WebDevServerInitGeneratorOptions;
    webDevServerPluginName: string;
}) => {
    plugin: string;
    options: {
        serveTargetName: string;
    };
};
