import { CreateNodes, CreateNodesV2, TargetConfiguration } from '@nx/devkit';
import { DevServerConfig } from '@web/dev-server';
import { RunCommandsOptions } from 'nx/src/executors/run-commands/run-commands.impl';
export interface DevServerCliArgs extends Partial<Pick<DevServerConfig, 'rootDir' | 'open' | 'appIndex' | 'preserveSymlinks' | 'nodeResolve' | 'watch' | 'esbuildTarget'>> {
    config?: string;
}
export type WebDevServerTargetConfiguration = TargetConfiguration<Partial<RunCommandsOptions> & DevServerCliArgs>;
export type WebDevServerTargetPluginSchema = {
    /**
     * The name of the `web-dev-server` serve target e.g. `'serve'` or
     * `'web-dev-server'`.
     */
    serveTargetName?: string;
    /** The configuration of the `web-dev-server` _serve_ target. */
    serveTargetConfig?: WebDevServerTargetConfiguration;
};
export type WebDevServerTargetPluginOptions = Required<WebDevServerTargetPluginSchema>;
export declare const WEB_DEV_SERVER_CONFIG_FILE_NAME_GLOB = "**/@(web-dev-server|wds).config.@(js|cjs|mjs)";
export declare const WEB_DEV_SERVER_COMMAND = "web-dev-server";
export declare const createNodes: CreateNodes<WebDevServerTargetPluginSchema>;
export declare const createNodesV2: CreateNodesV2<WebDevServerTargetPluginSchema>;
